/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*
     engine.h: Satellite tracking routines stolen from Predict           
               http://www.qsl.net/kd2bd/predict.html                     

  Copyright (C)  2001-2005  Alexandru Csete & John A. Magliacane.

  Authors:  Alexandru Csete <csete@users.sourceforge.net>,
            John A. Magliacane

  Comments, questions and bugreports should be submitted via
  http://sourceforge.net/projects/groundstation/
  More details can be found at http://groundstation.sourceforge.net/
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the
          Free Software Foundation, Inc.,
	  59 Temple Place, Suite 330,
	  Boston, MA  02111-1307
	  USA
*/

#ifndef ENGINE_H
#define ENGINE_H 1

#include "satdata.h"

gint engine_init   (void);
void engine_close  (void);
gint engine_reload (void);
void engine_update (void);
void engine_start  (void);
void engine_stop   (void);
void PreCalcAll    (gdouble);
void CalcAll       (void);

/* utility functions */
gboolean AosHappens (sat_t *);
gboolean Decayed (sat_t *,gdouble);
gboolean Geostationary (sat_t *);

#endif
