/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*
  satloc-tree.h:  Functions to read a specified locations file and
                  insert the locations into a GtkCTree.

  Copyright (C)  2001-2005  Alexandru Csete.

  Authors: Alexandru Csete <csete@users.sourceforge.net>

  Comments, questions and bugreports should be submitted via
  http://sourceforge.net/projects/groundstation/
  More details can be found at http://groundstation.sourceforge.net/
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the
          Free Software Foundation, Inc.,
	  59 Temple Place, Suite 330,
	  Boston, MA  02111-1307
	  USA
*/
#ifndef SATLOC_TREE_H
#define SATLOC_TREE_H 1


/* column order in tree */
enum satloc_tree_col_e {
	SATLOC_TREE_COL_LOC = 0,     /* Region/Sate/Location */
	SATLOC_TREE_COL_LAT,         /* Latitude in dd:mm:ss N/S */
	SATLOC_TREE_COL_LON,         /* Longitude in ddd:mm:ss E/W */
	SATLOC_TREE_COL_ALT,         /* Altitude in meters */
	SATLOC_TREE_COL_WX,          /* Weather station */
	SATLOC_TREE_COL_NUM          /* Number of columns */
};

GtkWidget *satloc_tree_create (void);

#endif
